/*
 * AbstractDBField.java
 *
 * Created on 3  2001 ., 18:04
 */

package com.fn.repway;

import java.util.*;
import org.w3c.dom.Element;

/**
 *
 * @author  asso
 * @version 
 */
public abstract class AbstractDBField implements DataField {

    protected String data = null;
    protected String fieldPath = null;
    
    public AbstractDBField() {
    }
    
    /** Creates new AbstractDBField */
    public AbstractDBField(Element tag) throws RepException {
        fieldPath = XMLUtils.getAttrib(tag, "data", (String)null);
        if (fieldPath == null)
            data = XMLUtils.getData(tag);
    }
  
    public AbstractDBField(String data) {
        this.data = data;
        if (data == null)
            this.data = "";
    }

    public abstract Value formatField(Value field) throws RepException;
    
    public Value getText(GenContext ctx) throws RepException {
        if (data != null)
            return formatField(new Value(data));
        else
            return formatField(ctx.getValue(fieldPath));
    }
    
}
