/*
 * FileDataLoader.java
 *
 * Created on 11  2001 ., 11:57
 */

package com.fn.repway;


import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;


/**
 *
 * @author  asso
 */
public class FileDataLoader implements DataLoader {

    private File baseDir;
    
    /** Creates a new instance of FileDataLoader */
    public FileDataLoader() {
        baseDir = null;
    }
    
    public FileDataLoader(File baseDir) {
        this.baseDir = baseDir;
    }

    public byte[] load(String name) throws RepException {
        byte[] data = null;
        try {
            File f;
            if (baseDir != null)
                f = new File(baseDir, name);
            else
                f = new File(name);
            if (! f.exists())
                throw new RepException("File not found");
            if (f.length() > 0x00FFFFFFF)
                throw new RepException("File is too large");
            int size = (int)f.length();
            data = new byte[size];
            InputStream is = new FileInputStream(f);
            is.read(data, 0, size);
            is.close();
        } catch (Exception e) {
            throw new RepException("Error loading file '" + name + "': " + e.getMessage());
        }
        return data;
    }
    
}
