/*
 * FloatFormatter.java
 *
 * Created on 1  2003 ., 16:42
 */

package com.fn.repway;


import java.text.NumberFormat;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class FloatFormatter implements DataField {
    
    private DataField field = null;
    private int maxFract;
    private int minFract;
    
    public FloatFormatter(Element tag) throws RepException {
	maxFract = XMLUtils.getAttrib(tag, "maxFract", -1);
	minFract = XMLUtils.getAttrib(tag, "minFract", -1);
        for (XMLIterator i = new XMLIterator(tag); i.hasNext(); ) {
            Element subtag = i.next();
            if (field != null)
                throw new RepException("Too many arguments to float formatter");
            field = FieldFactory.createField(subtag.getTagName(), subtag);
        }
    }
    
    public Value getText(GenContext ctx) throws RepException {
        double v = field.getText(ctx).getAsDouble();
        NumberFormat nf = NumberFormat.getNumberInstance();
        if (maxFract != -1)
            nf.setMaximumFractionDigits(maxFract);
        if (minFract != -1)
            nf.setMinimumFractionDigits(minFract);
        return new Value(nf.format(v));
    }
    
}
