/*
 * ImageStorage.java
 *
 * Created on 18  2003 ., 13:28
 */

package com.fn.repway;


import java.awt.image.BufferedImage;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import javax.imageio.ImageIO;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class ImageStorage implements OffscreenStorable {
    
    private Map images = new HashMap();
    
    /** Creates a new instance of ImageStorage */
    public ImageStorage() {
    }
    
    public ImageStorage(Element tag) throws RepException {
        for (XMLIterator i = new XMLIterator(tag); i.hasNext(); ) {
            Element subtag = i.next();
            if (subtag.getTagName().equals("image")) {
                try {
                    images.put(XMLUtils.getAttrib(subtag, "name", ""), 
                        ImageIO.read(new HexInputStream(XMLUtils.getData(subtag))));
                } catch (Exception e) {
                    throw new RepException("Error loading image from storage");
                }
            } else
                throw new RepException("Invalid image storage subtag");
        }
    }
    
    public void save(java.io.Writer out, String name) throws java.io.IOException {
        out.write("<imagestorage name=\"" + XMLUtils.escape(name) + "\">");
        for (Iterator i = images.entrySet().iterator(); i.hasNext(); ) {
            Map.Entry entry = (Map.Entry)i.next();
            String nm = (String)entry.getKey();
            BufferedImage image = (BufferedImage)entry.getValue();
            out.write("<image name=\"" + XMLUtils.escape(nm) + "\">");
            ImageIO.write(image, "png", new HexOutputStream(out));
            out.write("</image>");
        }
        out.write("</imagestorage>");
    }
    
    public void addImage(String name, BufferedImage image) {
        images.put(name, image);
    }
    
    public BufferedImage getImage(String name) {
        return (BufferedImage)images.get(name);
    }
}
