package com.fn.repway;

import java.text.*;
import java.util.*;
import org.w3c.dom.Element;

/**
 *
 * @author  asso
 */
public class MoneyFormatter implements DataField {

    private DataField field = null;
    
    /** Creates a new instance of TextVariable */
    public MoneyFormatter(Element tag) throws RepException {
        for (XMLIterator i = new XMLIterator(tag); i.hasNext(); ) {
            Element subtag = i.next();
            if (field != null)
                throw new RepException("Too many arguments to money formatter");
            field = FieldFactory.createField(subtag.getTagName(), subtag);
        }
    }
    
    public Value getText(GenContext ctx) throws RepException {
        NumberFormat nf = NumberFormat.getNumberInstance();
        nf.setMaximumFractionDigits(2);
        nf.setMinimumFractionDigits(2);
        if (field == null) 
            return new Value(nf.format(0.0));
        double v = field.getText(ctx).getAsDouble();
        return new Value(nf.format(v));
    }
    
}
