/*
 * Primitive.java
 *
 * Created on 9  2001 ., 18:32
 */

package com.fn.repway;


import java.io.IOException;
import java.io.Writer;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 * @version 
 */
abstract class Primitive {
    
    protected double left;
    protected double top;
    protected double width;
    protected double height;

    public Primitive() {
        this(0.0, 0.0, 0.0, 0.0);
    }
    
    /** Creates new Primitive */
    public Primitive(double left, double top, double width, double height) {
        this.left = left;
        this.top = top;
        this.width = width;
        this.height = height;
    }

    public Primitive(Element tag) throws RepException {
        left = XMLUtils.getAttrib(tag, "left", 0.0);
        top = XMLUtils.getAttrib(tag, "top", 0.0);
        width = XMLUtils.getAttrib(tag, "width", 0.0);
        height = XMLUtils.getAttrib(tag, "height", 0.0);
    }
    
    abstract void draw(java.awt.Graphics2D g2);
    
    public void moveBy(double deltaX, double deltaY) {
        left = left + deltaX;
        top = top + deltaY;
    }
    
    public double getLeft() {
        return left;
    }
    
    public double getTop() {
        return top;
    }
    
    protected void saveRectAttribs(Writer out) throws IOException {
        out.write(" left=\"");
        out.write(Double.toString(left));
        out.write("\" top=\"");
        out.write(Double.toString(top));
        out.write("\" width=\"");
        out.write(Double.toString(width));
        out.write("\" height=\"");
        out.write(Double.toString(height));
        out.write("\" ");
    }
    
    public abstract void save(Writer out) throws IOException;
    
}
