/*
 * Element.java
 *
 * Created on 9  2001 ., 16:46
 */

package com.fn.repway;

/**
 *
 * @author  asso
 * @version 
 */
public abstract class RepElement {
    
    protected double left;
    protected double top;
    protected double width;
    protected double height;
    
    /** Creates new Element */
    public RepElement(org.w3c.dom.Element tag) {
        left = XMLUtils.getAttrib(tag, "x", 0.0);
        top = XMLUtils.getAttrib(tag, "y", 0.0);
        width = XMLUtils.getAttrib(tag, "width", -1.0);
        height = XMLUtils.getAttrib(tag, "height", -1.0);
    }

    public abstract void generate(GenContext ctx, Band band, boolean front) throws RepException;
    
    public double getLeft() {
        return left;
    }
    
    public void setLeft(double v) {
        left = v;
    }
    
    public double getTop() {
        return top;
    }
    
    public void setTop(double v) {
        top = v;
    }

    public double getWidth() {
        return width;
    }
    
    public void setWidth(double v) {
        width = v;
    }

    public double getHeight() {
        return height;
    }
    
    public void setHeight(double v) {
        height = v;
    }
}
