/*
 * SectionMerger.java
 *
 * Created on 1  2003 ., 17:42
 */

package com.fn.repway;


import java.util.Iterator;
import java.util.List;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class SectionMerger extends RepElement {
    
    private Section section = null;
    private String sectionName;
    
    /** Creates a new instance of SectionMerger */
    public SectionMerger(Element tag) {
        super(tag);
        sectionName = XMLUtils.getData(tag);
    }
    
    public void generate(GenContext ctx, Band band, boolean front) throws RepException {
        if (section == null)
            section = ctx.getReport().getNamedSection(sectionName);
        if (section == null)
            throw new RepException("Section for include '" + sectionName + "' not found");
        List layers;
        if (front)
            layers = section.getFrontLayers();
        else
            layers = section.getBackLayers();
        if (layers == null)
            return;
        for (Iterator i = layers.listIterator(); i.hasNext(); )
            ((Layer)i.next()).generate(ctx, band, front);
    }
    
}
