/*
 * SimpleLayout.java
 *
 * Created on 1  2001 ., 23:13
 */

package com.fn.repway;


import java.util.*;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 * @version 
 */
public class SimpleLayout implements Layout {

    private double position;
    private Border border;
    private double pageHeight;
    private double footerHeight;
    
    /** Creates new SimpleLayout */
    public SimpleLayout() {
    }    
    
    public SimpleLayout(Element tag) {
    }

    public void begin(GenContext ctx) {
        border = ctx.getBorder();
        position = ctx.getPosition();
        PageFormat pageFormat = ctx.getPageFormat();
        if (pageFormat.getOrient() == PageFormat.LANDSCAPE)
            pageHeight = pageFormat.getWidth();
        else
            pageHeight = pageFormat.getHeight();
        Section pageFooter = ctx.getPageFooter();
        if (pageFooter != null)
            footerHeight = pageFooter.getHeight();
        else
            footerHeight = 0.0;
    }    
    
    public void addBand(GenContext ctx, Band band) throws RepException {
        Page page = ctx.getCurrentPage();
        double h = band.getHeight();
        if (position + h >= pageHeight - footerHeight - ctx.getPageBreaksHeight() - 
                border.getBottom()) {
            finishPage(ctx);
            startPage(ctx);
        }
        page = ctx.getCurrentPage();
        page.add(border.getLeft(), position, band);
        position += h;        
    }
    
    public void end(GenContext ctx) {
    }
    
    public void finishPage(GenContext ctx) throws RepException {
        Page page = ctx.getCurrentPage();
        for (Iterator i = ctx.getPageBreaks().listIterator(); i.hasNext(); ) {
            Band b = ((Section)i.next()).generateBody(ctx);
            page.add(border.getLeft(), position, b);
            position += b.getHeight();
        }
        Section pageFooter = ctx.getPageFooter();
        if (pageFooter != null) {
            Band band = pageFooter.generateBody(ctx);
            page.add(border.getLeft(), pageHeight - border.getBottom() - 
                pageFooter.getHeight(), band);
        }
        position = pageHeight;
    }
    
    public void startPage(GenContext ctx) throws RepException {
        Page p = ctx.getGenReport().addPage(ctx.getPageFormat());
        position = border.getTop();
        Section pageHeader = ctx.getPageHeader();
        if (pageHeader != null) {
            Band band = pageHeader.generateBody(ctx);
            p.add(border.getLeft(), border.getTop(), band);
            position += pageHeader.getHeight();
        }
        for (Iterator i = ctx.getPageStarts().listIterator(); i.hasNext(); ) {
            Band band = ((Section)i.next()).generateBody(ctx);
            p.add(border.getLeft(), position, band);
            position += band.getHeight();
        }
    }    
}
