/*
 * XMLIterator.java
 *
 * Created on 25  2003 ., 12:34
 */

package com.fn.repway;


import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


/**
 *
 * @author  asso
 */
public class XMLIterator {
    
    NodeList nodeList;
    Element element = null;
    int position;
    
    /** Creates a new instance of XMLIterator */
    public XMLIterator(Element parentTag) {
        nodeList = parentTag.getChildNodes();
        position = -1;
        moveToNext();
    }
    
    private void moveToNext() {
        Node node;
        position++;
        while (position < nodeList.getLength()) {
            node = nodeList.item(position);
            if (node == null) {
                element = null;
                return;
            }
            if (node.getNodeType() == Node.ELEMENT_NODE) {
                element = (Element)node;
                return;
            }
            position++;
        }
        element = null;
    }
    
    public boolean hasNext() {
        return element != null;
    }
    
    public Element next() {
        Element e = element;
        moveToNext();
        return e;
    }
}
