/*
 * MainWindow.java
 *
 * Created on 16  2004 ., 14:02
 */

package com.fn.repway.test;


import javax.swing.JOptionPane;

import com.fn.repway.RepException;


/**
 *
 * @author  asso
 */
public class MainWindow extends javax.swing.JFrame {

    private TestsListModel model = new TestsListModel();
    
    /** Creates new form MainWindow */
    public MainWindow() {
        initComponents();
        createTests();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        java.awt.Dimension windowSize = getSize();
        int x = (int)((screenSize.getWidth() - windowSize.getWidth()) / 2);
        int y = (int)((screenSize.getHeight() - windowSize.getHeight()) / 2);
        setLocation(x, y);
    }

    private void addTest(ReportTest test) {
        model.addElement(test);
    }
    
    private void createTests() {
        addTest(new BasicTest());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel2 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        runBtn = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        testsList = new javax.swing.JList();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Test ReportWay");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanel2.setLayout(new java.awt.BorderLayout());

        jPanel2.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));

        jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(0, 8, 0, 0)));
        runBtn.setText("Run");
        runBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                runBtnActionPerformed(evt);
            }
        });

        jPanel1.add(runBtn);

        jPanel2.add(jPanel1, java.awt.BorderLayout.EAST);

        jLabel1.setText("Select test to run:");
        jPanel2.add(jLabel1, java.awt.BorderLayout.NORTH);

        testsList.setModel(model);
        testsList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        testsList.setCellRenderer(new TestListCellRenderer());
        testsList.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                testsListMouseClicked(evt);
            }
        });

        jScrollPane1.setViewportView(testsList);

        jPanel2.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void runBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_runBtnActionPerformed
        int idx = testsList.getSelectedIndex();
        if (0 <= idx) {
            ReportTest test = (ReportTest)model.get(idx);
            try {
                test.runTest();
            } catch (RepException e) {
                e.printStackTrace();
                JOptionPane.showMessageDialog(this, e.getMessage());
            }
        }
    }//GEN-LAST:event_runBtnActionPerformed

    private void testsListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_testsListMouseClicked
        if (2 == evt.getClickCount()) 
            runBtnActionPerformed(null);
    }//GEN-LAST:event_testsListMouseClicked
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton runBtn;
    private javax.swing.JList testsList;
    // End of variables declaration//GEN-END:variables
    
}
